library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity add_struct is
  port (
    a, b : in  unsigned(3 downto 0);
    s    : out unsigned(3 downto 0);
    cout : out std_logic
    );
end ;

architecture arc of add_struct is
  
  component full_add1 is
    port
      (a, b, cin : in  std_logic;
       s, cout   : out std_logic);
  end component full_add1;

  signal c : unsigned(2 downto 0);

begin

  inst_full_add0 : full_add1 port map (a(0), b(0),  '0', s(0), c(0));
  inst_full_add1 : full_add1 port map (a(1), b(1), c(0), s(1), c(1));
  inst_full_add2 : full_add1 port map (a(2), b(2), c(1), s(2), c(2));
  inst_full_add7 : full_add1 port map (a(3), b(3), c(2), s(3), cout);  
end arc;


